import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class Algarv {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int i, n = scanner.nextInt();
        for (i = 0; i < n; i++) {
            int k = scanner.nextInt();
            kivid[k]++;
            trahv += ((k == 0) ? 10 : k);
        }

        alg();
        otsi(0,0,0,0,0,0);

        System.out.println(p_pikkus + " " + parim);
        for (i=0;i<p_pikkus;i++) {
            System.out.println(p_kaigud[i] + " " + p_pk[i]);
        }
        System.out.println(p_trahv);
    }

    static Map<Integer, Integer> acache = new TreeMap<>();
    static Map<Integer, Integer> pyga = new TreeMap<>();
    static int MS = 9000000;
    static char[] soel = new char[MS];

    static void alg() {
        int i,j;
        for (i=0;i<MS;i++)
            soel[i] = 1;
        soel[0] = 0;
        soel[1] = 0;
        for (i=0;i<MS;i++) {
            if (soel[i] == 1)
                for (j=2 * i; j < MS ; j += i)
                    soel[j] = 0;

        }
    }

    static int parim = -99999;
    static int p_pikkus;
    static int[] p_kaigud = new int[12];
    static int[] p_pk = new int[12];
    static int p_trahv;
    static int[] kaigud = new int[12];
    static int[] pk = new int[12];

    static int[] kivid = {0,0,0,0,0,0,0,0,0,0};
    static int trahv;

    static int onalgarv(int p) {
        int i;
        if (p < MS)
            return soel[p];

        if (!acache.containsKey(p)) {
            for (i = 2; i <= Math.sqrt(p); i++) {
                if ((i < MS ) && (soel[i] == 0))
                    continue;
                if (p % i == 0) {
                    acache.put(p, 0);
                    return 0;
                }
            }
            acache.put(p, 1);
        }
        return acache.get(p);
    }

/* pikkus - otsingutee pikkus


*/

    static void otsi(int pikkus, int punktid,  int laual, int vasak, int parem, int mask) {
        int i;
        if (pikkus > 0) {
            kaigud[pikkus-1] = vasak;

            if (onalgarv(vasak) > 0) {
                punktid += laual;
            }

            if (onalgarv(parem) > 0) {
                punktid += laual;
            }
            pk[pikkus - 1] = punktid;

        }

        if ((mask == 0) || onalgarv(vasak) > 0 || onalgarv(parem) > 0) {
            if (parim < (punktid - trahv + laual)) {
                parim = punktid - trahv + laual;
                p_pikkus = pikkus;
                for (i=0;i<pikkus;i++) {
                    p_kaigud[i] = kaigud[i];
                    p_pk[i] = pk[i];
                }
                p_trahv = laual - trahv;
            }
        }

        if (!pyga.containsKey( (vasak > parem ) ? vasak : parem)) {
            pyga.put((vasak > parem ) ? vasak : parem, punktid);
        } else {
            if (pyga.get((vasak > parem ) ? vasak : parem) >= punktid)
                return;
        }

        for (i=9;i>=0;i--) {
            if (kivid[i] > 0)  {
                kivid[i]--;

                if (mask == 0)	{
                    otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), i, i, 1);
                } else {
                    otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), mask * 10 * i + vasak,  parem * 10 + i, mask * 10);
                    if (vasak != parem)
                        otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), vasak * 10 + i, mask * 10 * i + parem, mask * 10);

                }

                kivid[i]++;
            }

        }
    }
}
